
package de.ivu.elect.presentation.kandidatur;

import java.util.Collection;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.gruppe.entity.Gruppe;
import de.ivu.elect.business.kandidatur.boundary.EinzelbewerberKandidaturKonfiguration;
import de.ivu.elect.business.kandidatur.boundary.KandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Direktkandidatur;
import de.ivu.elect.business.person.entity.Personendaten;
import de.ivu.elect.business.personenregister.boundary.PersonenregisterByPersonendatenSearchParameters;
import de.ivu.elect.business.personenregister.boundary.PersonenregisterPersonendatenConversationSelect;
import de.ivu.elect.business.personenregister.control.KandidaturPersonenregisterPersonendatenMapper;
import de.ivu.elect.business.personenregister.entity.PersonenregisterPersonendaten;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.business.wahl.entity.Wahl;
import de.ivu.elect.business.wahlvorschlag.boundary.EinzelbewerberWahlvoschlagBoundaryCreate;
import de.ivu.elect.business.wahlvorschlag.entity.Direktkandidat;
import de.ivu.elect.business.wahlvorschlag.entity.WahlvorschlagReihenfolgeBestaetigenEvent;
import de.ivu.elect.business.wahlvorschlag.entity.Wahlvorschlagsdokument;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.jee.presentation.redirect.Redirect;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.kandidatur.form.EinzelbewerberKandidaturViewFormBuilder;
import de.ivu.elect.presentation.wahlvorschlag.WahlvorschlagEmpfangsquittungDokumentErzeugenView;
import de.ivu.elect.presentation.wahlvorschlag.WahlvorschlagsdokumentFactory;
import de.ivu.elect.presentation.wahlvorschlag.form.WahlvorschlagsdokumenteViewFormBuilder;

@OnlineHilfeId(value = "157", mehrfachVergebenOk = true)
@Named(EinzelbewerberDirektkandidaturCreateView.COMPONENT_NAME)
@View(viewId = EinzelbewerberDirektkandidaturCreateView.VIEW_ID, useCase = UseCasePermission.DIREKTKANDIDATUR_CREATE)
public class EinzelbewerberDirektkandidaturCreateView extends AbstractDirektkandidaturCreateView {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "einzelbewerberDirektkandidaturCreateView";

  public static final String VIEW_ID = "/kandidatur/einzelbewerber-direktkandidatur-create.xhtml";

  @Inject
  protected transient EinzelbewerberWahlvoschlagBoundaryCreate einzelbewerberWahlvoschlagBoundaryCreate;

  @Inject
  protected transient KandidaturConversationSelect uebergeordneteKandidaturSelect;

  @Inject
  protected transient PersonenregisterPersonendatenConversationSelect personenregisterPersonendatenSelect;

  @Inject
  protected transient KandidaturPersonenregisterPersonendatenMapper kandidaturPersonenregisterPersonendatenMapper;

  @Inject
  protected transient WahlvorschlagsdokumentFactory wahlvorschlagsdokumentFactory;

  @Inject
  protected transient WahlvorschlagsdokumenteViewFormBuilder wahlvorschlagsdokumenteViewFormBuilder;

  @Inject
  @View
  protected transient WahlvorschlagEmpfangsquittungDokumentErzeugenView wahlvorschlagEmpfangsquittungDokumentErzeugenView;

  @Inject
  protected transient EinzelbewerberDirektkandidaturCreateViewHelper einzelbewerberDirektkandidaturCreateViewHelper;

  @Inject
  protected transient EinzelbewerberDirektkandidaturCreateViewResolver einzelbewerberDirektkandidaturCreateViewResolver;

  @Inject
  protected transient ErsatzkandidaturCreateViewResolver ersatzkandidaturCreateViewResolver;

  @Inject
  protected transient WahlvorschlagReihenfolgeBestaetigenEvent wahlvorschlagReihenfolgeBestaetigenEvent;

  protected Collection<Wahlvorschlagsdokument> wahlvorschlagsdokumente;

  public EinzelbewerberDirektkandidaturCreateView() {
    super();
  }

  public void preRenderView() {
    einzelbewerberDirektkandidaturCreateViewHelper.preRenderView();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    return einzelbewerberDirektkandidaturCreateViewHelper.checkPreCondition();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public String getGebietName() {
    return getSelectedGebietNameFormatted();
  }

  private Wahl getWahl() {
    return getSelectedGebiet().getWahl();
  }

  protected Direktkandidat getEinzelkandidat() {
    return getEntity().getDirektkandidat();
  }

  protected Gruppe getEinzelbewerber() {
    return getEntity().getGruppe();
  }

  @Override
  @PostConstruct
  public void init() {
    super.init();

    einzelbewerberDirektkandidaturCreateViewHelper.init(getSelectedGebiet(), getEntity());

    initWahlvorschlagsdokumente();

    tryPresetPersonenregisterPersonendaten();
  }

  private void initWahlvorschlagsdokumente() {
    this.wahlvorschlagsdokumente = wahlvorschlagsdokumentFactory.createAllWahlvorschlagsdokumenteForEntity(getEinzelkandidat());
  }

  private void tryPresetPersonenregisterPersonendaten() {
    if (isPersonenregisterPersonendatenSelected()) {
      initPersonenregisterPersonendaten(getPersonenregisterPersonendaten());
    } else if (isPersonenregisterByPersonendatenSearchParametersSelected()) {
      initPersonenregisterPersonendaten(getPersonenregisterByPersonendatenSearchParameters());
    }
  }

  private boolean isPersonenregisterPersonendatenSelected() {
    return personenregisterPersonendatenSelect.isPersonenregisterPersonendatenSelected();
  }

  private PersonenregisterPersonendaten getPersonenregisterPersonendaten() {
    return personenregisterPersonendatenSelect.getPersonenregisterPersonendaten();
  }

  private void initPersonenregisterPersonendaten(PersonenregisterPersonendaten personenregisterPersonendaten) {
    Personendaten personendaten = getEntity();

    kandidaturPersonenregisterPersonendatenMapper.mapManuelleAuswahl(personendaten, personenregisterPersonendaten);
    einzelbewerberDirektkandidaturCreateViewHelper.tryAttachStaatsangehoerigkeiten(personendaten);
  }

  private boolean isPersonenregisterByPersonendatenSearchParametersSelected() {
    return personenregisterPersonendatenSelect.isPersonenregisterByPersonendatenSearchParametersSelected();
  }

  private PersonenregisterByPersonendatenSearchParameters getPersonenregisterByPersonendatenSearchParameters() {
    return personenregisterPersonendatenSelect.getPersonenregisterByPersonendatenSearchParameters();
  }

  private void initPersonenregisterPersonendaten(PersonenregisterByPersonendatenSearchParameters searchParameters) {
    Personendaten personendaten = getEntity();
    personendaten.setFamilienname(searchParameters.getFamilienname());
    personendaten.setRufname(searchParameters.getVorname());
    personendaten.setGeburtsdatum(searchParameters.getGeburtsdatum());
    personendaten.setGeschlecht(searchParameters.getGeschlecht());
  }

  protected Collection<Wahlvorschlagsdokument> getWahlvorschlagsdokumente() {
    return wahlvorschlagsdokumente;
  }

  @Override
  public void addProperties(FormBuilder formBuilder, Direktkandidatur einzelkandidatur) {
    boolean readonly = false;

    getViewFormBuilder().addProperties(formBuilder, einzelkandidatur, readonly);

    wahlvorschlagsdokumenteViewFormBuilder.addProperties(formBuilder, getSelectedWahl(), getEinzelkandidat(), getWahlvorschlagsdokumente(), readonly);
  }

  @Override
  @Redirect
  @UseCaseSecure(UseCasePermission.DIREKTKANDIDATUR_CREATE)
  public String save() {
    Direktkandidatur einzelkandidatur = getEntity();

    getViewFormBuilder().preSaveEntity(einzelkandidatur);

    saveEntities(einzelkandidatur);

    addMessageSaveSuccess(einzelkandidatur);

    return goBack(getParentViewId());
  }

  @Override
  protected void addMessageSaveSuccess(Direktkandidatur einzelkandidatur) {
    addInfoMessage("entity.create.action.save.success.message", getMessage(EinzelbewerberKandidaturKonfiguration.MSG_KEY_EINZELBEWERBER_DIREKTKANDIDATUR_EINZAHL));
  }

  protected void saveEntities(Direktkandidatur einzelkandidatur) {
    Direktkandidat einzelkandidat = getEinzelkandidat();

    einzelbewerberWahlvoschlagBoundaryCreate.saveAndCreateEinzelkandidaturAndWahlvorschlagsdokumente(einzelkandidat, einzelkandidatur, getWahlvorschlagsdokumente());

    wahlvorschlagReihenfolgeBestaetigenEvent.sendWahlvorschlagReihenfolgeBestaetigenEvent(einzelkandidat.getPk());
  }

  public boolean isBtnSaveAndEinzelkandidaturCreateRendered() {
    return hasPermission(UseCasePermission.DIREKTKANDIDATUR_CREATE);
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.DIREKTKANDIDATUR_CREATE)
  public String saveAndEinzelkandidaturCreate() {
    save();
    init();

    return einzelbewerberDirektkandidaturCreateViewResolver.getViewId(getMandant());
  }

  public boolean isBtnSaveAndErsatzkandidaturCreateRendered() {
    return hasPermission(UseCasePermission.ERSATZKANDIDATUR_CREATE) && ersatzkandidaturCreateViewResolver.isUntergeordneteErsatzkandidaturCreatable(getWahl(), getEntity());
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERSATZKANDIDATUR_CREATE)
  public String saveAndErsatzkandidaturCreate() {
    save();

    uebergeordneteKandidaturSelect.setEntity(getEntity());

    return ersatzkandidaturCreateViewResolver.getViewId(getMandant());
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ERSATZKANDIDATUR_CREATE)
  public String saveAndEmpfangsquittungDokumentErzeugen() {
    save();

    return wahlvorschlagEmpfangsquittungDokumentErzeugenView.init(getEinzelkandidat());
  }

  public boolean isSaveAndEmpfangsquittungDokumentErzeugenRendered() {
    return hasPermission(UseCasePermission.DOKUMENT_ERZEUGEN_WAHLVORSCHLAG_EMPFANGSQUITTUNG) && wahlvorschlagEmpfangsquittungDokumentErzeugenView.isDokumentErzeugungMoeglich();
  }

  @Override
  @Redirect
  public String goBack() {
    super.goBack();

    if (personenregisterPersonendatenSelect.isSelected()) {
      personenregisterPersonendatenSelect.clear();
    }

    return getParentViewId();
  }

  protected EinzelbewerberKandidaturViewFormBuilder getViewFormBuilder() {
    return einzelbewerberDirektkandidaturCreateViewHelper.getViewFormBuilder();
  }

  @Override
  protected FormBuilder createFormBuilder() {
    return new FormBuilder(formBuilderConfig);
  }
}
